/*******************************************************************************
 * FoxGameSettingsCommon generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameSettingsCommon extends OnlineGameSettings
    native;

const CONTEXT_PRESENCE_MENUPRESENCE = 0;
const CONTEXT_PRESENCE_PRESENCE_PLAYING = 1;
const CONTEXT_GAME_MODE = 0x0000800B;
const CONTEXT_GAME_MODE_DM = 0;
const CONTEXT_GAME_MODE_TDM = 1;
const CONTEXT_GAME_MODE_CP = 2;
const CONTEXT_GAME_MODE_TKOTH = 3;
const CONTEXT_GAME_MODE_CTF = 4;
const CONTEXT_GAME_MODE_CTDM = 5;
const CONTEXT_GAME_MODE_EOTS = 6;
const CONTEXT_GAME_MODE_PL = 7;
const CONTEXT_GAME_MODE_KC = 8;
const CONTEXT_GAME_MODE_OS = 9;
const CONTEXT_GAME_MODE_SND = 10;
const CONTEXT_GAME_MODE_DETONATE = 1002;
const CONTEXT_GAME_MODE_LMS = 1003;
const CONTEXT_GAME_MODE_LTS = 1004;
const CONTEXT_GAME_MODE_BO = 1005;
const CONTEXT_LOCKEDSERVER = 1;
const CONTEXT_MAPNAME = 2;
const CONTEXT_MAPNAME_CUSTOM = 0;
const CONTEXT_MAPNAME_BLACKMARKET = 1;
const CONTEXT_MAPNAME_BRUTALISM = 2;
const CONTEXT_MAPNAME_CURFEW = 3;
const CONTEXT_MAPNAME_DERAILER = 4;
const CONTEXT_MAPNAME_DROPZONE = 5;
const CONTEXT_MAPNAME_FLOODGATE = 6;
const CONTEXT_MAPNAME_MAUL = 7;
const CONTEXT_MAPNAME_PITFALL = 8;
const CONTEXT_MAPNAME_POSTALLEY = 9;
const CONTEXT_MAPNAME_SKYFIRE = 10;
const CONTEXT_MAPNAME_SLUMLORD = 11;
const CONTEXT_MAPNAME_WHARFARE = 12;
const CONTEXT_MAPNAME_ZEROPOINT = 13;
const CONTEXT_MAPNAME_STREETFIGHT = 14;
const CONTEXT_MAPNAME_TOURISTTRAP = 15;
const CONTEXT_MAPNAME_BURIALGROUND = 16;
const CONTEXT_MAPNAME_BRICKANDMORTAR = 17;
const CONTEXT_LOCKEDSERVER_NO = 0;
const CONTEXT_LOCKEDSERVER_YES = 1;
const PROPERTY_CUSTOMMAPNAME = 0x40000001;
const PROPERTY_CUSTOMGAMEMODE = 0x40000002;
const PROPERTY_SERVERDESCRIPTION = 0x40000003;
const PROPERTY_MAPNAME = 0x40000004;
const PROPERTY_GAMETYPE = 0x40000005;
const PROPERTY_GAMEPASSWORD = 0x40000006;
const PROPERTY_ADMINPASSWORD = 0x40000007;
const PROPERTY_OWNERNAME = 0x40000008;
const PROPERTY_SERVERNAME = 0x40000009;
const PROPERTY_SERVERID = 0x4000000A;
const PROPERTY_GAME_VERSION = 0x50000074;
const PROPERTY_GAME_OPEN = 0x10000076;
const PROPERTY_PUBLIC_GAME = 0x10000078;
const PROPERTY_PLAYLISTNAME = 0x10000079;
const PROPERTY_MAPINDEX = 0x1000007A;
const PROPERTY_GAMEINDEX = 0x1000007B;
const PROPERTY_MINLEVEL = 0x1000007C;
const PROPERTY_MAXLEVEL = 0x1000007D;
const PROPERTY_XPMULT = 0x1000007E;
const PROPERTY_GPMULT = 0x1000007F;
const PROPERTY_CPMULT = 0x10000080;
const PROPERTY_GAMESTATE = 0x10000081;
const PROPERTY_TIMEREMAINING = 0x10000082;
const PROPERTY_PLAYLISTINFO1 = 0x10000083;
const PROPERTY_PLAYLISTINFO2 = 0x10000084;
const PROPERTY_PLAYLISTINFO3 = 0x10000085;
const PROPERTY_PLAYLISTINFO4 = 0x10000086;
const PROPERTY_MAX_TICK_RATE = 0x10000087;
const PROPERTY_PREMIUMTOKENGUID = 0x10000088;
const PROPERTY_ADVERTISEDXPMULT = 0x10000089;
const PROPERTY_ADVERTISEDCPMULT = 0x1000008A;
const PROPERTY_ADVERTISEDGPMULT = 0x1000008B;
const PROPERTY_MUTATORTOGGLE = 0x1000008C;
const PROPERTY_NUM_BOTS = 0x1000008D;
const PROPERTY_MAX_CP = 0x1000008E;
const PROPERTY_STARTING_CP = 0x1000008F;
const PROPERTY_PING_THRESHOLD = 0x10000090;
const PROPERTY_TIME_LIMIT = 0x10000091;
const PROPERTY_GOALSCORE_MULT = 0x10000092;
const PROPERTY_SERVERACCESSTYPE = 0x10000093;
const PROPERTY_PLAYERWHITELIST = 0x10000094;
const PROPERTY_CLANWHITELIST = 0x10000095;
const PROPERTY_BANLIST = 0x10000096;
const PROPERTY_RANDOMPLAYLIST = 0x10000097;
const PROPERTY_REGIONTAG = 0x10000098;
const PROPERTY_SERVERTYPE = 0x10000099;
const PROPERTY_QUERYPREMIUM = 0x1000009A;
const PROPERTY_OWNERID = 0x1000009B;
const PROPERTY_MAXPLAYERS = 0x1000009C;
const PROPERTY_MAXSPECTATORS = 0x1000009D;
const PROPERTY_PREMIUM_SERVER_GUID = 0x1000009E;
const PROPERTY_SERVER_EXPIRATION = 0x1000009F;
const PROPERTY_SAVEDMAPINFO1 = 0x10000100;
const PROPERTY_SAVEDMAPINFO2 = 0x10000101;
const PROPERTY_SAVEDMAPINFO3 = 0x10000102;
const PROPERTY_SAVEDGAMEMODEINFO1 = 0x10000103;
const PROPERTY_SAVEDGAMEMODEINFO2 = 0x10000104;
const PROPERTY_DIFFICULTY = 0x10000105;
const PROPERTY_SAVEDMAPINFO4 = 0x10000106;
const PROPERTY_SERVERPREFIX = 0x10000107;
const PROPERTY_HEALTH_MULTIPLIER = 0x10000108;
const PROPERTY_ADMINLIST = 0x10000109;
const PROPERTY_ADVERTISED_TIMELIMIT = 0x1000010A;
const PROPERTY_STAMINA_MULTIPLIER = 0x1000010B;
const PROPERTY_NUM_ROUNDS = 0x1000010C;
const PROPERTY_ADVERTISED_ROUND = 0x1000010D;
const PROPERTY_TEAM_TICKETS = 0x1000010E;
const PROPERTY_PERSONAL_TICKETS = 0x1000010F;
const PROPERTY_ROUND_TEAM_SWAP = 0x10000110;
const PROPERTY_NUM_SPECTATORS = 0x10000111;
const PROPERTY_PLAYLIST_INDEX = 0x10001000;
const PROPERTY_PROFILE_SKILL = 0x10001001;
const PROPERTY_PROFILE_RANK_INDEX = 0x10001010;
const PROPERTY_PLAYLIST_SEARCH_FILTER = 0x10001011;
const PROPERTY_NUM_PLAYLIST_MAX = 0x10001012;
const PROPERTY_MINPRESTIGE = 0x10001013;
const PROPERTY_MAXPRESTIGE = 0x10001014;
const QUERY_DM = 0;
const QUERY_TDM = 1;
const QUERY_CP = 2;
const QUERY_DETONATE = 3;
const QUERY_CTF = 4;
const QUERY_CTDM = 5;
const QUERY_LMS = 6;
const QUERY_LTS = 7;
const QUERY_BO = 8;
const QUERY_TKOTH = 9;
const QUERY_EOTS = 10;
const QUERY_PL = 11;
const QUERY_KC = 12;
const QUERY_SND = 13;
const PROPERTY_LEADERBOARDRATING = 0x20000009;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME = 1;
const STATS_VIEW_LEADERBOARD_RANKEDALLTIME = 2;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_DM = 3;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_TDM = 4;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_CTF = 5;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_CP = 6;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_DET = 7;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_LMS = 8;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_LTS = 9;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_BO = 10;
const STATS_VIEW_LEADERBOARD_WEAPONSALLTIME = 11;
const STATS_VIEW_LEADERBOARD_PLAYERALLTIME_PS3 = 12;
const STATS_VIEW_PROFILESTATS = 13;
const RANDOM_MAP = 0x00000001;
const RANDOM_GAMETYPE = 0x00000002;

var bool bIsDirty;
var string GameType;
var UniqueNetId BackupHostID;

// Export UFoxGameSettingsCommon::execStringToBlob(FFrame&, void* const)
native static function bool StringToBlob(const out string InString, out string OutBlob);

// Export UFoxGameSettingsCommon::execBlobToString(FFrame&, void* const)
native static function string BlobToString(const out string InBlob);

function UpdateFromURL(const out string URL, GameInfo Game)
{
    local FoxGame FGame;
    local string GamePassword, ServerName, Region;
    local float HealthModifier;
    local int pos;
    local string playlistName;
    local int PlaylistIndex, MaxPlayersVal;
    local FoxDataStore_Playlists PlaylistDataStore;
    local int MapData[4], CurrentMapData, GameData, CurrentGameData, I;

    local string OptionValue;

    FGame = FoxGame(Game);
    PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    GetMapAndGameDataFromProperties(CurrentMapData, CurrentGameData);
    super(Settings).UpdateFromURL(URL, Game);
    I = 0;
    J0xB1:
    // End:0x294 [Loop If]
    if(I < Properties.Length)
    {
        // End:0x286
        if(class'GameInfo'.static.HasOption(URL, string(PropertyMappings[I].Name)))
        {
            OptionValue = class'GameInfo'.static.ParseOption(URL, string(PropertyMappings[I].Name));
            switch(Properties[I].Data.Type)
            {
                // End:0x1FC
                case 1:
                    SetIntProperty(Properties[I].PropertyId, int(OptionValue));
                    // End:0x286
                    break;
                // End:0x23D
                case 4:
                    SetStringProperty(Properties[I].PropertyId, OptionValue);
                    // End:0x286
                    break;
                // End:0x280
                case 5:
                    SetFloatProperty(Properties[I].PropertyId, float(OptionValue));
                    // End:0x286
                    break;
                // End:0xFFFF
                default:
                    // End:0x286
                    break;
                }
        }
        ++ I;
        // [Loop Continue]
        goto J0xB1;
    }
    GetFloatProperty(268435720, HealthModifier);
    // End:0x2D3
    if(HealthModifier == 0.0)
    {
        SetFloatProperty(268435720, 1.0);
    }
    GamePassword = GetGamePasswordPropertyValue();
    // End:0x325
    if(Left(GamePassword, 1) == "\\"")
    {
        SetStringProperty(1073741830, Mid(GamePassword, 1, Len(GamePassword) - 2));
    }
    ServerName = GetServerName();
    // End:0x377
    if(Left(ServerName, 1) == "\\"")
    {
        SetStringProperty(1073741833, Mid(ServerName, 1, Len(ServerName) - 2));
    }
    // End:0x48D
    if(FGame != none)
    {
        GetIntProperty(268435612, MaxPlayersVal);
        SetIntProperty(268435613, FGame.MaxSpectators);
        // End:0x48D
        if((MaxPlayersVal == 0) && class'GameInfo'.static.HasOption(URL, "MaxPlayers"))
        {
            MaxPlayersVal = class'GameInfo'.static.GetIntOption(URL, "MaxPlayers", 16);
            SetIntProperty(268435612, MaxPlayersVal);
            // End:0x48D
            if(NumOpenSlots == 0)
            {
                NumOpenSlots = MaxPlayersVal;
            }
        }
    }
    // End:0x50F
    if((Game.WorldInfo.NetMode == NM_DedicatedServer) || class'GameInfo'.static.HasOption(URL, "Dedicated"))
    {
        bIsDedicated = true;
    }
    bUsesArbitration = bUsesArbitration || class'GameInfo'.static.HasOption(URL, "Ranked");
    pos = InStr(URL, "?Playlist=", false, true, 0);
    // End:0x638
    if(pos != -1)
    {
        playlistName = Split(URL, "?Playlist=", true);
        pos = InStr(playlistName, "?");
        // End:0x606
        if(pos != -1)
        {
            playlistName = Left(playlistName, pos);
        }
        PlaylistIndex = PlaylistDataStore.GetPlaylistIndexFromPlaylistString(playlistName);
    }
    // End:0x6DF
    if(class'GameInfo'.static.HasOption(URL, "PI"))
    {
        PlaylistIndex = class'GameInfo'.static.GetIntOption(URL, "PI", 0);
        // End:0x6DF
        if(PlaylistIndex >= 0)
        {
            playlistName = PlaylistDataStore.GetPlaylistName(PlaylistIndex);
        }
    }
    // End:0x906
    if(playlistName != "")
    {
        // End:0x795
        if(playlistName != "CustomPrivate")
        {
            SetPlaylistIndexPropertyValue(PlaylistIndex);
            SetIntProperty(268439569, 1 << PlaylistIndex);
            // End:0x792
            if(PlaylistDataStore.LastLoadedPlaylistName != name(playlistName))
            {
                PlaylistDataStore.SelectPlaylistByName(name(playlistName));
            }
        }
        // End:0x8F0
        else
        {
            GetMapAndGameDataFromURL(URL, MapData, GameData);
            SetPlaylistIndexPropertyValue(-1);
            // End:0x8F0
            if((PlaylistDataStore.LastLoadedPlaylistName != name(PlaylistDataStore.CustomPrivatePlaylistName)) || !IsMatchingPlaylistData(CurrentMapData, CurrentGameData, MapData, GameData))
            {
                SetPlaylistSettingsFromData(MapData, GameData);
                PlaylistDataStore.BuildAndSetPlaylistProviderFromSettings(MapData, GameData, 0);
                PlaylistDataStore.LastLoadedPlaylistName = name(PlaylistDataStore.CustomPrivatePlaylistName);
                PlaylistDataStore.bBuiltFromOfficialPlaylist = false;
            }
        }
        SetPlaylistNamePropertyValue(playlistName);
        J0x906:
    }
    // End:0x906
    else
    {
    }
    SetStringSettingValue(1, 0, false);
    pos = InStr(URL, "?Region=", false, true, 0);
    // End:0x9D4
    if(pos != -1)
    {
        Region = Split(URL, "?Region=", true);
        pos = InStr(Region, "?");
        // End:0x9BC
        if(pos != -1)
        {
            Region = Left(Region, pos);
        }
        SetStringProperty(268435608, Region);
    }
    bIsDirty = true;
    //return;    
}

function GetMapAndGameDataFromURL(string InURL, out int OutMapData[4], out int OutGameData[2])
{
    OutMapData[0] = class'GameInfo'.static.GetIntOption(InURL, "MI1", 0);
    OutMapData[1] = class'GameInfo'.static.GetIntOption(InURL, "MI2", 0);
    OutMapData[2] = class'GameInfo'.static.GetIntOption(InURL, "MI3", 0);
    OutMapData[3] = class'GameInfo'.static.GetIntOption(InURL, "MI4", 0);
    OutGameData[0] = class'GameInfo'.static.GetIntOption(InURL, "GI1", 0);
    OutGameData[1] = class'GameInfo'.static.GetIntOption(InURL, "GI2", 0);
    //return;    
}

function GetMapAndGameDataFromProperties(out int OutMapData[4], out int OutGameData[2])
{
    GetIntProperty(268435712, OutMapData[0]);
    GetIntProperty(268435713, OutMapData[1]);
    GetIntProperty(268435714, OutMapData[2]);
    GetIntProperty(268435718, OutMapData[3]);
    GetIntProperty(268435715, OutGameData[0]);
    GetIntProperty(268435716, OutGameData[1]);
    //return;    
}

function bool IsMatchingPlaylistData(int InCurrentMapData[4], int InCurrentGameData[2], int InCheckedMapData[4], int InCheckedGameData[2])
{
    local bool bIsMatch;

    bIsMatch = (((((InCurrentMapData[0] == InCheckedMapData[0]) && InCurrentMapData[1] == InCheckedMapData[1]) && InCurrentMapData[2] == InCheckedMapData[2]) && InCurrentMapData[3] == InCheckedMapData[3]) && InCurrentGameData[0] == InCheckedGameData[0]) && InCurrentGameData[1] == InCheckedGameData[1];
    return bIsMatch;
    //return ReturnValue;    
}

function UpdateAdvertisedSettings(FoxGame FGame)
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxGRI GRI;
    local float AdvertisedXPMult, AdvertisedCPMult, AdvertisedGPMult;
    local int MapData[4], GameTypeData, OldMaxPlayers;

    GRI = FoxGRI(FGame.WorldInfo.GRI);
    // End:0x4C4
    if(GRI != none)
    {
        SetMapIndex(GRI.NextMapIndex);
        SetStringProperty(1073741829, GameType);
        // End:0xED
        if(FGame.ServerType == 0)
        {
            SetIntProperty(268435717, FGame.Difficulty);
        }
        GetIntProperty(268435612, OldMaxPlayers);
        SetIntProperty(268435585, GRI.GameStatus);
        SetIntProperty(268435586, GRI.RemainingTime);
        SetIntProperty(268435722, GRI.TimeLimit);
        SetIntProperty(268435729, FGame.NumSpectators);
        SetIntProperty(268435612, GRI.MaxPlayers);
        AdvertisedXPMult = GRI.PlaylistXPModifier * GRI.GameXPModifier;
        AdvertisedCPMult = GRI.PlaylistCPModifier * GRI.GameCPModifier;
        AdvertisedGPMult = GRI.PlaylistGPModifier * GRI.GameGPModifier;
        AdvertisedXPMult *= GRI.PrivateMatchXPModifier;
        AdvertisedGPMult *= GRI.PrivateMatchGPModifier;
        SetFloatProperty(268435593, AdvertisedXPMult);
        SetFloatProperty(268435595, AdvertisedGPMult);
        SetFloatProperty(268435594, AdvertisedCPMult);
        PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
        // End:0x474
        if(PlaylistDataStore != none)
        {
            // End:0x474
            if(PlaylistDataStore.HasPlaylist())
            {
                PlaylistDataStore.BuildCurrentPlaylistSettings(MapData, GameTypeData);
                SetPlaylistSettingsFromData(MapData, GameTypeData);
                // End:0x474
                if(PlaylistDataStore.bBuiltFromOfficialPlaylist)
                {
                    SetPlaylistType(PlaylistDataStore.RandomType);
                }
            }
        }
        SetRoundInfo(GRI.CurrentRoundNum + 1, GRI.NumRounds);
    }
    bIsDirty = true;
    //return;    
}

event InitializeOnMigration()
{
    local int OldMaxPlayers;

    GetIntProperty(268435612, OldMaxPlayers);
    SetToDefaults();
    SetIntProperty(268435612, OldMaxPlayers);
    //return;    
}

// Export UFoxGameSettingsCommon::execSetToDefaults(FFrame&, void* const)
native function SetToDefaults();

function SetMapName(string NewMapName)
{
    SetStringProperty(1073741828, NewMapName);
    //return;    
}

function SetMapContextFromMapName(string NewMapName)
{
    local DataStoreClient DSClient;
    local FoxDataStore_MenuItems MenuItemsDataStore;
    local FoxDataProvider_MapInfo MapInfo;

    DSClient = class'UIInteraction'.static.GetDataStoreClient();
    // End:0x74
    if(DSClient != none)
    {
        MenuItemsDataStore = FoxDataStore_MenuItems(DSClient.FindDataStore('FoxMenuItems'));
    }
    MapInfo = MenuItemsDataStore.GetMapInfoByMapName(NewMapName);
    SetMapContextByIndex(MapInfo.PresenceContext);
    //return;    
}

function SetMapContextByIndex(int NewIndex)
{
    SetStringSettingValue(2, NewIndex, false);
    bIsDirty = true;
    //return;    
}

function int GetMapIndex()
{
    local int MapIndex;

    MapIndex = -1;
    GetIntProperty(268435578, MapIndex);
    return MapIndex;
    //return ReturnValue;    
}

function SetMapIndex(int NewIndex)
{
    SetIntProperty(268435578, NewIndex);
    //return;    
}

function int GetGameModeIndex()
{
    local int GameModeIndex;

    GameModeIndex = -1;
    GetIntProperty(268435579, GameModeIndex);
    return GameModeIndex;
    //return ReturnValue;    
}

function SetGameModeIndex(int NewIndex)
{
    SetIntProperty(268435579, NewIndex);
    //return;    
}

function SetAdminPassword(string NewAdminPassword)
{
    SetStringProperty(1073741831, NewAdminPassword);
    //return;    
}

function SetGameStatus(bool bGameIsOpen)
{
    SetIntProperty(268435574, ((bGameIsOpen) ? 1 : 0));
    //return;    
}

function SetGameVersion(int NewGameVersion)
{
    SetIntProperty(1342177396, NewGameVersion);
    //return;    
}

simulated event string GetMapNamePropertyValue()
{
    local string PropertyMapName;

    GetStringProperty(1073741828, PropertyMapName);
    return PropertyMapName;
    //return ReturnValue;    
}

simulated event string GetPlaylistNamePropertyValue()
{
    local string PropertyPlaylistName;

    GetStringProperty(268435577, PropertyPlaylistName);
    return PropertyPlaylistName;
    //return ReturnValue;    
}

simulated event SetPlaylistIndexPropertyValue(int Index)
{
    SetIntProperty(268439552, Index);
    //return;    
}

simulated event SetPlaylistNamePropertyValue(string playlistName)
{
    SetStringProperty(268435577, playlistName);
    //return;    
}

simulated event int GetMaxPlayersPropertyValue()
{
    local int MaxPlayersVal;

    GetIntProperty(268435612, MaxPlayersVal);
    return MaxPlayersVal;
    //return ReturnValue;    
}

simulated event string GetGameTypePropertyValue()
{
    local string PropertyGameType;

    GetStringProperty(1073741829, PropertyGameType);
    return PropertyGameType;
    //return ReturnValue;    
}

simulated event string GetOwnerNamePropertyValue()
{
    local string OwnerName;

    GetStringProperty(1073741832, OwnerName);
    return OwnerName;
    //return ReturnValue;    
}

simulated event string GetServerDescriptionPropertyValue()
{
    local string PropertyServerDescription;

    GetStringProperty(1073741827, PropertyServerDescription);
    return PropertyServerDescription;
    //return ReturnValue;    
}

simulated event string GetGamePasswordPropertyValue()
{
    local string PropertyGamePassword;

    GetStringProperty(1073741830, PropertyGamePassword);
    return PropertyGamePassword;
    //return ReturnValue;    
}

simulated event string GetAdminPasswordPropertyValue()
{
    local string PropertyAdminPassword;

    GetStringProperty(1073741831, PropertyAdminPassword);
    return PropertyAdminPassword;
    //return ReturnValue;    
}

simulated event int GetGameVersionPropertyValue()
{
    local int ProperyGameVersion;

    GetIntProperty(1342177396, ProperyGameVersion);
    return ProperyGameVersion;
    //return ReturnValue;    
}

simulated function float GetCPMultipler()
{
    local float Mult;

    // End:0x3A
    if((GetFloatProperty(268435584, Mult)) && Mult > 0.010)
    {
        return Mult;
    }
    return 1.0;
    //return ReturnValue;    
}

simulated function float GetGPMultipler()
{
    local float Mult;

    // End:0x3A
    if((GetFloatProperty(268435583, Mult)) && Mult > 0.010)
    {
        return Mult;
    }
    return 1.0;
    //return ReturnValue;    
}

simulated function float GetXPMultipler()
{
    local float Mult;

    // End:0x3A
    if((GetFloatProperty(268435582, Mult)) && Mult > 0.010)
    {
        return Mult;
    }
    return 1.0;
    //return ReturnValue;    
}

function float GetAdvertisedXPMultiplier()
{
    local float Mult;

    // End:0x3A
    if((GetFloatProperty(268435593, Mult)) && Mult > 0.010)
    {
        return Mult;
    }
    return 1.0;
    //return ReturnValue;    
}

function float GetAdvertisedGPMultiplier()
{
    local float Mult;

    // End:0x3A
    if((GetFloatProperty(268435595, Mult)) && Mult > 0.010)
    {
        return Mult;
    }
    return 1.0;
    //return ReturnValue;    
}

function float GetAdvertisedCPMultiplier()
{
    local float Mult;

    // End:0x3A
    if((GetFloatProperty(268435594, Mult)) && Mult > 0.010)
    {
        return Mult;
    }
    return 1.0;
    //return ReturnValue;    
}

simulated function bool GetMaxServerTickRate(out int OutRate)
{
    return (GetIntProperty(268435591, OutRate)) && OutRate != 0;
    //return ReturnValue;    
}

simulated event bool IsPublicGame()
{
    local int PublicGameVal;

    GetIntProperty(268435576, PublicGameVal);
    return PublicGameVal == 1;
    //return ReturnValue;    
}

simulated function bool IsGameOpen()
{
    return true;
    //return ReturnValue;    
}

// Export UFoxGameSettingsCommon::execSetPropertyFromStringByName(FFrame&, void* const)
native function bool SetPropertyFromStringByName(name PropertyName, const out string NewValue);

// Export UFoxGameSettingsCommon::execCopyProperties(FFrame&, void* const)
native function CopyProperties(FoxGameSettingsCommon FromSettings);

private final function SetPlaylistSettingsFromData(int InMapData[4], int InGameData[2])
{
    SetIntProperty(268435712, InMapData[0]);
    SetIntProperty(268435713, InMapData[1]);
    SetIntProperty(268435714, InMapData[2]);
    SetIntProperty(268435718, InMapData[3]);
    SetIntProperty(268435715, InGameData[0]);
    SetIntProperty(268435716, InGameData[1]);
    //return;    
}

function SetPlaylistInfoFromProviders(array<FoxDataProvider_MapInfo> InMapProviders, array<FoxDataProvider_GameModeInfo> InGameProviders)
{
    local FoxDataStore_Playlists PlaylistsDataStore;
    local int MapData[4], GameData;

    PlaylistsDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    PlaylistsDataStore.BuildPlaylistSettingsFromProviders(InMapProviders, InGameProviders, MapData, GameData);
    SetPlaylistSettingsFromData(MapData, GameData);
    //return;    
}

function GetBuildPlaylistInfo(out array<FoxDataProvider_MapInfo> OutMapProviders, out array<FoxDataProvider_GameModeInfo> OutGameProviders)
{
    local FoxDataStore_Playlists PlaylistsDataStore;
    local int MapData[4], GameData;

    GetMapAndGameDataFromProperties(MapData, GameData);
    PlaylistsDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
    PlaylistsDataStore.BuildPlaylistInfoBySettings(MapData, GameData, OutMapProviders, OutGameProviders);
    //return;    
}

function FoxTypes.EPlaylistType GetPlaylistType()
{
    local int PlaylistType;

    GetIntProperty(268435607, PlaylistType);
    return byte(PlaylistType);
    //return ReturnValue;    
}

function SetPlaylistType(FoxTypes.EPlaylistType PlaylistType)
{
    SetIntProperty(268435607, PlaylistType);
    //return;    
}

function SetMutatorSetting(const int InSetting)
{
    SetIntProperty(268435596, InSetting);
    //return;    
}

function bool GetMutatorSetting(out int OutSetting)
{
    return GetIntProperty(268435596, OutSetting);
    //return ReturnValue;    
}

function bool IsMutatorSettingEnabled(Engine.OnlineSubsystemTypes.EMutatorToggleType Mutator)
{
    local int MutatorSetting;

    GetIntProperty(268435596, MutatorSetting);
    return ((1 << Mutator) & MutatorSetting) > 0;
    //return ReturnValue;    
}

function SetUsesWhitelist(bool bUsesWhiteList)
{
    SetIntProperty(268435603, ((bUsesWhiteList) ? 1 : 0));
    //return;    
}

function bool UsesWhitelist()
{
    local int WhitelistSetting;

    return (GetIntProperty(268435603, WhitelistSetting)) && WhitelistSetting > 0;
    //return ReturnValue;    
}

function SetPlayerWhiteList(array<string> PlayerIDs)
{
    local string WhiteListString;
    local int I;

    I = 0;
    J0x0B:
    // End:0x8C [Loop If]
    if(I < PlayerIDs.Length)
    {
        WhiteListString $= PlayerIDs[I];
        // End:0x7E
        if((I + 1) < PlayerIDs.Length)
        {
            WhiteListString $= "-";
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    SetRawPlayerWhitelist(WhiteListString);
    //return;    
}

function SetRawPlayerWhitelist(string InRawList)
{
    SetStringProperty(268435604, InRawList);
    //return;    
}

function array<string> GetWhitelistedPlayers()
{
    return SplitString(GetRawPlayerWhitelist(), "-");
    //return ReturnValue;    
}

function string GetRawPlayerWhitelist()
{
    local string WhiteListString;

    GetStringProperty(268435604, WhiteListString);
    return WhiteListString;
    //return ReturnValue;    
}

function SetClanWhiteList(array<string> ClanNames)
{
    local string WhiteListString;
    local int I;

    I = 0;
    J0x0B:
    // End:0x8C [Loop If]
    if(I < ClanNames.Length)
    {
        WhiteListString $= ClanNames[I];
        // End:0x7E
        if((I + 1) < ClanNames.Length)
        {
            WhiteListString $= "-";
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    SetRawClanWhitelist(WhiteListString);
    //return;    
}

function SetRawClanWhitelist(string InRawList)
{
    SetStringProperty(268435605, InRawList);
    //return;    
}

function bool AddWhiteListedClan(string ClanName)
{
    local array<string> WhiteListedClans;

    WhiteListedClans = GetWhitelistedClans();
    // End:0x5B
    if(WhiteListedClans.Find(ClanName) < 0)
    {
        WhiteListedClans.AddItem(ClanName);
        SetClanWhiteList(WhiteListedClans);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function bool AddWhiteListedPlayer(string PlayerID)
{
    local array<string> WhitelistedPlayers;

    WhitelistedPlayers = GetWhitelistedPlayers();
    // End:0x5B
    if(WhitelistedPlayers.Find(PlayerID) < 0)
    {
        WhitelistedPlayers.AddItem(PlayerID);
        SetPlayerWhiteList(WhitelistedPlayers);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function bool RemoveWhiteListedPlayer(string PlayerID)
{
    local array<string> WhitelistedPlayers;

    WhitelistedPlayers = GetWhitelistedPlayers();
    // End:0x5B
    if(WhitelistedPlayers.Find(PlayerID) >= 0)
    {
        WhitelistedPlayers.RemoveItem(PlayerID);
        SetPlayerWhiteList(WhitelistedPlayers);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function array<string> GetWhitelistedClans()
{
    return SplitString(GetRawClanWhitelist(), "-");
    //return ReturnValue;    
}

function string GetRawClanWhitelist()
{
    local string WhiteListString;

    GetStringProperty(268435605, WhiteListString);
    return WhiteListString;
    //return ReturnValue;    
}

function SetBannedPlayers(array<string> BannedPlayerIDs)
{
    local string BanString;
    local int I;

    I = 0;
    J0x0B:
    // End:0x8C [Loop If]
    if(I < BannedPlayerIDs.Length)
    {
        BanString $= BannedPlayerIDs[I];
        // End:0x7E
        if((I + 1) < BannedPlayerIDs.Length)
        {
            BanString $= "-";
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    SetRawBanList(BanString);
    //return;    
}

function SetRawBanList(string InRawList)
{
    SetStringProperty(268435606, InRawList);
    //return;    
}

function array<string> GetBannedPlayers()
{
    return SplitString(GetRawBanList(), "-");
    //return ReturnValue;    
}

function string GetRawBanList()
{
    local string BannedPlayersString;

    GetStringProperty(268435606, BannedPlayersString);
    return BannedPlayersString;
    //return ReturnValue;    
}

function bool AddBannedPlayer(string PlayerID)
{
    local array<string> BannedPlayers;

    BannedPlayers = GetBannedPlayers();
    // End:0x5B
    if(BannedPlayers.Find(PlayerID) < 0)
    {
        BannedPlayers.AddItem(PlayerID);
        SetBannedPlayers(BannedPlayers);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function bool RemoveBannedPlayer(string PlayerID)
{
    local array<string> BannedPlayers;

    BannedPlayers = GetBannedPlayers();
    // End:0x5B
    if(BannedPlayers.Find(PlayerID) >= 0)
    {
        BannedPlayers.RemoveItem(PlayerID);
        SetBannedPlayers(BannedPlayers);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function SetAdminList(array<PlayerNameIdPair> NewAdminList)
{
    local string AdminList;
    local int I;

    I = 0;
    J0x0B:
    // End:0xEB [Loop If]
    if(I < NewAdminList.Length)
    {
        AdminList $= ((NewAdminList[I].PlayerName $ ".") $ class'FoxGame'.static.ConvertUniqueIdToString(NewAdminList[I].UniqueId));
        // End:0xDD
        if((I + 1) < NewAdminList.Length)
        {
            AdminList $= "-";
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    SetRawAdminList(AdminList);
    //return;    
}

function string GetRawAdminList()
{
    local string AdminList;

    GetStringProperty(268435721, AdminList);
    return AdminList;
    //return ReturnValue;    
}

function SetRawAdminList(string RawAdminString)
{
    SetStringProperty(268435721, RawAdminString);
    //return;    
}

function array<PlayerNameIdPair> GetAdminList()
{
    return GetAdminsFromRawString(GetRawAdminList());
    //return ReturnValue;    
}

static function array<PlayerNameIdPair> GetAdminsFromRawString(string RawAdminString)
{
    local array<string> AdminEntries;
    local array<PlayerNameIdPair> Result;
    local PlayerNameIdPair NewPair;
    local array<string> StringNameIdPairs;
    local int I;

    AdminEntries = SplitString(RawAdminString, "-");
    I = 0;
    J0x2C:
    // End:0x113 [Loop If]
    if(I < AdminEntries.Length)
    {
        StringNameIdPairs = SplitString(AdminEntries[I], ".");
        // End:0x105
        if(StringNameIdPairs.Length == 2)
        {
            NewPair.PlayerName = StringNameIdPairs[0];
            NewPair.UniqueId = class'FoxGame'.static.ConvertStringToUniqueID(StringNameIdPairs[1]);
            Result.AddItem(NewPair);
        }
        ++ I;
        // [Loop Continue]
        goto J0x2C;
    }
    return Result;
    //return ReturnValue;    
}

function bool AddAdmin(string PlayerName, UniqueNetId InUniqueId)
{
    local array<PlayerNameIdPair> AdminList;
    local PlayerNameIdPair NewEntry;
    local int I;

    AdminList = GetAdminList();
    I = 0;
    J0x1F:
    // End:0xB8 [Loop If]
    if(I < AdminList.Length)
    {
        // End:0xAA
        if((AdminList[I].PlayerName == PlayerName) || AdminList[I].UniqueId == InUniqueId)
        {
            return false;
        }
        ++ I;
        // [Loop Continue]
        goto J0x1F;
    }
    NewEntry.PlayerName = PlayerName;
    NewEntry.UniqueId = InUniqueId;
    AdminList.AddItem(NewEntry);
    SetAdminList(AdminList);
    return true;
    //return ReturnValue;    
}

function bool RemoveAdmin(string PlayerName)
{
    local array<PlayerNameIdPair> AdminList;
    local int FoundIndex;

    AdminList = GetAdminList();
    FoundIndex = AdminList.Find('PlayerName', PlayerName);
    // End:0x76
    if(FoundIndex >= 0)
    {
        AdminList.Remove(FoundIndex, 1);
        SetAdminList(AdminList);
        return true;
    }
    return false;
    //return ReturnValue;    
}

function SetServerType(Engine.OnlineSubsystemTypes.EServerDesignationType InServerType)
{
    SetIntProperty(268435609, InServerType);
    //return;    
}

event Engine.OnlineSubsystemTypes.EServerDesignationType GetServerType()
{
    local int SettingVal;

    GetIntProperty(268435609, SettingVal);
    return byte(SettingVal);
    //return ReturnValue;    
}

function string GetServerName()
{
    local string OutServerName;

    GetStringProperty(1073741833, OutServerName);
    return OutServerName;
    //return ReturnValue;    
}

function string GetPremiumServerID()
{
    local string PremiumServerGuid;

    GetStringProperty(268435614, PremiumServerGuid);
    return PremiumServerGuid;
    //return ReturnValue;    
}

function bool DoesPlayerOwnsServer(UniqueNetId PlayerUniqueId)
{
    local UniqueNetId StoredId;
    local string UniqueIDString;

    GetStringProperty(268435611, UniqueIDString);
    class'OnlineSubsystem'.static.StringToUniqueNetId(UniqueIDString, StoredId);
    return StoredId == PlayerUniqueId;
    //return ReturnValue;    
}

function bool HasAdminAccess(UniqueNetId UniqueId)
{
    return (DoesPlayerOwnsServer(UniqueId)) || IsInAdminList(UniqueId);
    //return ReturnValue;    
}

function bool IsInAdminList(UniqueNetId UniqueId)
{
    local array<PlayerNameIdPair> AdminList;
    local int I;

    AdminList = GetAdminList();
    I = 0;
    J0x1F:
    // End:0x82 [Loop If]
    if(I < AdminList.Length)
    {
        // End:0x74
        if(AdminList[I].UniqueId == UniqueId)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x1F;
    }
    return false;
    //return ReturnValue;    
}

function string GetRawExpirationDate()
{
    local string DateTimeString;

    GetStringProperty(268435615, DateTimeString);
    return DateTimeString;
    //return ReturnValue;    
}

function FoxDateTime GetExpirationDateTime()
{
    local FoxDateTime OutTime;

    class'FoxDateTimeHelper'.static.ParseFromString(GetRawExpirationDate(), OutTime);
    return OutTime;
    //return ReturnValue;    
}

function bool IsExpired()
{
    return bServerExpired;
    //return ReturnValue;    
}

function array<int> GetPlaylistIds()
{
    local array<int> Result;

    Result.AddItem(268435607);
    Result.AddItem(268435712);
    Result.AddItem(268435713);
    Result.AddItem(268435714);
    Result.AddItem(268435718);
    Result.AddItem(268435715);
    Result.AddItem(268435716);
    return Result;
    //return ReturnValue;    
}

function SetDifficulty(FoxTypes.EDifficultyLevel NewDifficultyLevel)
{
    SetIntProperty(268435717, NewDifficultyLevel);
    //return;    
}

function FoxTypes.EDifficultyLevel GetDifficulty()
{
    local int DifficultyValue;

    GetIntProperty(268435717, DifficultyValue);
    return byte(DifficultyValue);
    //return ReturnValue;    
}

function SetRoundInfo(int CurrentRoundNum, int MaxRoundNums)
{
    SetIntProperty(268435725, CurrentRoundNum | (MaxRoundNums << 4));
    //return;    
}

function GetRoundInfo(out int OutCurrentRoundNum, out int OutMaxRounds)
{
    local int RoundInfo;

    GetIntProperty(268435725, RoundInfo);
    OutCurrentRoundNum = RoundInfo & 15;
    OutMaxRounds = RoundInfo >> 4;
    //return;    
}

function SetRoundTeamSwapType(Engine.OnlineSubsystemTypes.ERoundTeamSwapType NewType)
{
    SetIntProperty(268435728, NewType);
    //return;    
}

function Engine.OnlineSubsystemTypes.ERoundTeamSwapType GetRoundTeamSwapType()
{
    local int SwapVal;

    GetIntProperty(268435728, SwapVal);
    return byte(SwapVal);
    //return ReturnValue;    
}

function int GetNumSpectators()
{
    local int OutVal;

    GetIntProperty(268435729, OutVal);
    return OutVal;
    //return ReturnValue;    
}

event string GetPlaylistFriendlyName()
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxDataProvider_Playlist PlaylistData;
    local int Index;

    // End:0xCD
    if(GetIntProperty(268439552, Index))
    {
        PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
        PlaylistData = PlaylistDataStore.GetPlaylistByIndex(Index);
        // End:0xCD
        if(PlaylistData != none)
        {
            return PlaylistData.FriendlyName;
        }
    }
    return "";
    //return ReturnValue;    
}

event string GetPlaylistFriendlyDescription()
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxDataProvider_Playlist PlaylistData;
    local int Index;

    // End:0xCD
    if(GetIntProperty(268439552, Index))
    {
        PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
        PlaylistData = PlaylistDataStore.GetPlaylistByIndex(Index);
        // End:0xCD
        if(PlaylistData != none)
        {
            return PlaylistData.FriendlyDescription;
        }
    }
    return "";
    //return ReturnValue;    
}

event bool GetPlaylistPlayGoAvailable()
{
    local FoxDataStore_Playlists PlaylistDataStore;
    local FoxDataProvider_Playlist PlaylistData;
    local int Index;

    // End:0xD2
    if(GetIntProperty(268439552, Index))
    {
        PlaylistDataStore = FoxDataStore_Playlists(class'UIInteraction'.static.GetDataStoreClient().FindDataStore('FoxPlaylists'));
        PlaylistData = PlaylistDataStore.GetPlaylistByIndex(Index);
        // End:0xD2
        if(PlaylistData != none)
        {
            return PlaylistData.RequiredChunks[0] == 0;
        }
    }
    return false;
    //return ReturnValue;    
}

static function bool IsPlayerLevelRestrictedWithReason(int game_maxlevel, int game_minlevel, int game_maxprestige, int game_minprestige, int PlayerLevel, int PlayerPrestige, out FoxTypes.EPlayerLevelRestrictionReason ErrorReason)
{
    local int AdjustedPlayerLevel;

    ErrorReason = 0;
    AdjustedPlayerLevel = PlayerLevel + (PlayerPrestige * class'FoxUnlockInfo'.default.RankData.Length);
    // End:0x81
    if((game_minprestige != 0) && PlayerPrestige < game_minprestige)
    {
        ErrorReason = 3;
        return true;
    }
    // End:0xB7
    if((game_maxprestige != 0) && PlayerPrestige > game_maxprestige)
    {
        ErrorReason = 4;
        return true;
    }
    // End:0x148
    if((game_minlevel != 0) && PlayerLevel < game_minlevel)
    {
        // End:0x148
        if(((((game_minprestige == 0) && game_maxprestige == 0) && AdjustedPlayerLevel < game_minlevel) || game_minprestige != 0) || game_maxprestige != 0)
        {
            ErrorReason = 1;
            return true;
        }
    }
    // End:0x1C6
    if(game_maxlevel != 0)
    {
        // End:0x1A1
        if((game_minprestige != 0) || game_maxprestige != 0)
        {
            // End:0x19F
            if(PlayerLevel > game_maxlevel)
            {
                ErrorReason = 2;
                return true;
            }
            // End:0x1A1
            else
            {
                return false;
            }
        }
        // End:0x1C6
        if(AdjustedPlayerLevel > game_maxlevel)
        {
            ErrorReason = 2;
            return true;
        }
    }
    return false;
    //return ReturnValue;    
}

event bool IsPlayerLevelRestricted(int PlayerLevel, int PlayerPrestige)
{
    local int MaxLevel, MinLevel, MaxPrestige, MinPrestige;
    local FoxTypes.EPlayerLevelRestrictionReason FailReason;

    GetIntProperty(268435580, MinLevel);
    GetIntProperty(268435581, MaxLevel);
    GetIntProperty(268439571, MinPrestige);
    GetIntProperty(268439572, MaxPrestige);
    return IsPlayerLevelRestrictedWithReason(MaxLevel, MinLevel, MaxPrestige, MinPrestige, PlayerLevel, PlayerPrestige, FailReason);
    //return ReturnValue;    
}

event bool IsPlayerLevelRestrictedAll(int game_maxlevel, int game_minlevel, int game_maxprestige, int game_minprestige, int PlayerLevel, int PlayerPrestige)
{
    local FoxTypes.EPlayerLevelRestrictionReason FailReason;

    return IsPlayerLevelRestrictedWithReason(game_maxlevel, game_minlevel, game_maxprestige, game_minprestige, PlayerLevel, PlayerPrestige, FailReason);
    //return ReturnValue;    
}

defaultproperties
{
    bIsDirty=true
    GameType="All"
    NumOpenSlots=16
    LocalizedSettings=/* Array type was not detected. */
    Properties=/* Array type was not detected. */
    LocalizedSettingsMappings=/* Array type was not detected. */
    PropertyMappings=/* Array type was not detected. */
}